#ifndef _KGR_PATCH_BSC1080338_H
#define _KGR_PATCH_BSC1080338_H

#if IS_ENABLED(CONFIG_X86_64)

int kgr_patch_bsc1090338_init(void);
void kgr_patch_bsc1090338_cleanup(void);

struct fpu;
struct task_struct;
struct user_regset;
void kgr_fpu__clear(struct fpu *fpu);
int kgr_arch_dup_task_struct(struct task_struct *dst, struct task_struct *src);
int kgr__fpu__restore_sig(void __user *buf, void __user *buf_fx, int size);
int kgr_xstateregs_set(struct task_struct *target,
		       const struct user_regset *regset,
		       unsigned int pos, unsigned int count,
		       const void *kbuf, const void __user *ubuf);

#define KGR_PATCH_BSC1090338_FUNCS					\
	KGR_PATCH(fpu__clear, kgr_fpu__clear),				\
	KGR_PATCH(arch_dup_task_struct, kgr_arch_dup_task_struct),	\
	KGR_PATCH(__fpu__restore_sig, kgr__fpu__restore_sig),		\
	KGR_PATCH(xstateregs_set, kgr_xstateregs_set),			\


#else /* !IS_ENABLED(CONFIG_X86_64) */

static inline int kgr_patch_bsc1090338_init(void) { return 0; }
static inline void kgr_patch_bsc1090338_cleanup(void) {}

#define KGR_PATCH_BSC1090338_FUNCS

#endif /* IS_ENABLED(CONFIG_X86_64) */

#endif
